__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Hello world in pygame, with numpy manipulation
"""

import pygame
import sys
import numpy as N
import Numeric

pygame.display.init()
try:
    pygame.font.init()
except Exception, e:
    print "Unable to initialise font module"
    print e
    sys.exit()


size=(800,600)
screen=pygame.display.set_mode(size)
pygame.display.set_caption("Hello World")
screen=pygame.display.get_surface()

conSurface=pygame.Surface((10,10),0,32)
font=pygame.font.SysFont('Comic',120)
text=font.render('Hello World!',True,(128, 128, 128)).convert_alpha()
screen.blit(text,(1,1))
tt=text.copy()
tt.blit(screen,(1,1),(1,1,1+tt.get_width(),1+tt.get_height()))

textArray=N.array(pygame.surfarray.array3d(tt))
print textArray.shape
for y in range(textArray.shape[1]):
    textArray[:,y,0][textArray[:,y,0]>100]+=y-20
    textArray[:,y,1][textArray[:,y,1]<100]+=170-y
for x in range(textArray.shape[0]):
    textArray[x,:,2][textArray[x,:,2]>100]+=x/6

text2=pygame.surfarray.make_surface(Numeric.array(textArray)).convert_alpha()

screen.blit(text2,(1,1))

pygame.display.update()

oClock=pygame.time.Clock()

while True:
    oClock.tick(40)
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
        elif event.type == pygame.KEYDOWN and event.key == pygame.K_q:
            sys.exit()
