__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Hello world in pygame, with a ball (why not?)
"""

import pygame
import sys, os

pygame.display.init()
try:
    pygame.font.init()
except Exception, e:
    print "Unable to initialise font module"
    print e
    sys.exit()

size=(800,600)
screen=pygame.display.set_mode(size)
pygame.display.set_caption("Hello World")
screen=pygame.display.get_surface()

font=pygame.font.Font(None,90)
text=font.render('Hello World!',True,(128, 128, 128))
screen.blit(text,(5,5))
pygame.display.update()

name=os.path.join('images','blue_circ_8bit.png')
ball=pygame.image.load(name)
ballrect=ball.get_rect(centerx=screen.get_width()/2,
                       centery=screen.get_height()/2)
screen.blit(ball,ballrect)

pygame.display.update(ballrect)

while True:
    event=pygame.event.poll()
    if event.type == pygame.QUIT:
        sys.exit()
    elif event.type == pygame.KEYUP and event.key == pygame.K_q:
        sys.exit()
